Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -1923,59 +2981,97 @@
 				$this->config_array['im_combine_filename']='composite';
 			}
 
-			if (isset($index[$v]['convert']) && $this->checkIMlzw)	{
+			if (isset($index[$v]['convert']) && $this->checkIMlzw) {
 				$index[$v]['gif_capability'] = ''.$this->_checkImageMagickGifCapability($v);
 			}
 		}
 		$this->config_array['im_versions']=$index;
-		if (!$this->config_array['im'])	{
-			$this->message($ext, 'No ImageMagick installation available',"
-			It seems that there is no adequate ImageMagick installation available at the checked locations (".implode($paths, ', ').")
-			An 'adequate' installation for requires 'convert', 'combine'/'composite' and 'identify' to be available
-			",2);
+		if (!$this->config_array['im']) {
+			$this->message($ext, 'No ImageMagick installation available', '
+				<p>
+					It seems that there is no adequate ImageMagick installation
+					available at the checked locations (' . implode(', ', $paths) . ')
+					<br />
+					An \'adequate\' installation for requires \'convert\',
+					\'combine\'/\'composite\' and \'identify\' to be available
+				</p>
+			', 2);
 		} else {
-			$theCode='';
-			reset($this->config_array['im_versions']);
-			while(list($p,$v)=each($this->config_array['im_versions']))	{
-				$ka=array();
+				// Get the subpart for the ImageMagick versions
+			$theCode = $this->contentObject->getSubpart($templateFile, '###VERSIONS###');
+				// Get the subpart for each ImageMagick version
+			$rowsSubPart = $this->contentObject->getSubpart($theCode, '###ROWS###');
+
+			foreach ($this->config_array['im_versions'] as $p => $v) {
+				$ka = array();
 				reset($v);
-				while(list($ka[])=each($v)){}
-				$theCode.='<tr><td>'.$this->fw($p).'</td><td>'.$this->fw(implode($ka,'<br />')).'</td><td>'.$this->fw(implode($v,'<br />')).'</td></tr>';
+				while(list($ka[])=each($v)) {}
+					// Define the markers content
+				$rowsMarkers = array(
+					'file' => $p,
+					'type' => implode('<br />', $ka),
+					'version' => implode('<br />', $v)
+				);
+					// Fill the markers in the subpart
+				$rows[] = $this->contentObject->substituteMarkerArray(
+					$rowsSubPart,
+					$rowsMarkers,
+					'###|###',
+					1,
+					1
+				);
 			}
-			$this->message($ext, 'Available ImageMagick/GraphicsMagick installations:','<table border="1" cellpadding="2" cellspacing="2">'.$theCode.'</table>',-1);
+				// Substitute the subpart for the ImageMagick versions
+			$theCode = $this->contentObject->substituteSubpart(
+				$theCode,
+				'###ROWS###',
+				implode(chr(10), $rows)
+			);
+				// Add the content to the message array
+			$this->message($ext, 'Available ImageMagick/GraphicsMagick installations:', $theCode, -1);
 		}
-		$this->message($ext, 'Search for ImageMagick:','
-			<form action="'.$this->action.'" method="post">
-				<input type="checkbox" name="TYPO3_INSTALL[checkIM][lzw]" id="checkImLzw" value="1"'.($this->INSTALL['checkIM']['lzw']?' checked="checked"':'').'> <label for="checkImLzw">Check LZW capabilities.</label>
-
-				Check this path for ImageMagick installation:
-				<input type="text" name="TYPO3_INSTALL[checkIM][path]" value="'.htmlspecialchars($this->INSTALL['checkIM']['path']).'">
-				(Eg. "D:\wwwroot\im537\ImageMagick\" for Windows or "/usr/bin/" for Unix)<br />
-
-				<input type="submit" value="Send">
-			</form>
-		',0);
-
+			// Get the template file
+		$formSubPart = $this->contentObject->getSubpart($templateFile, '###FORM###');
+			// Define the markers content
+		$formMarkers = array(
+			'actionUrl' => $this->action,
+			'lzwChecked' => ($this->INSTALL['checkIM']['lzw'] ? 'checked="checked"' : ''),
+			'lzwLabel' => 'Check LZW capabilities.',
+			'checkPath' => 'Check this path for ImageMagick installation:',
+			'imageMagickPath' => htmlspecialchars($this->INSTALL['checkIM']['path']),
+			'comment' => '(Eg. "D:\wwwroot\im537\ImageMagick\" for Windows or "/usr/bin/" for Unix)',
+			'send' => 'Send'
+		);
+			// Fill the markers
+		$formSubPart = $this->contentObject->substituteMarkerArray(
+			$formSubPart,
+			$formMarkers,
+			'###|###',
+			1,
+			1
+		);
+			// Add the content to the message array
+		$this->message($ext, 'Search for ImageMagick:', $formSubPart, 0);
 	}
 
 	/**
 	 * Checking GIF-compression capabilities of ImageMagick install
 	 *
-	 * @param	[type]		$file: ...
-	 * @return	[type]		...
+	 * @param string $path Path of ImageMagick installation
+	 * @return string Type of compression
 	 */
-	function _checkImageMagickGifCapability($path)	{
-		if ($this->config_array['dir_typo3temp'])	{		//  && !$this->config_array['safemode']
+	function _checkImageMagickGifCapability($path) {
+		if ($this->config_array['dir_typo3temp']) { //  && !$this->config_array['safemode']
 			$tempPath = $this->typo3temp_path;
 			$uniqueName = md5(uniqid(microtime()));
 			$dest = $tempPath.$uniqueName.'.gif';
 			$src = $this->backPath.'gfx/typo3logo.gif';
-			if (@is_file($src) && !strstr($src,' ') && !strstr($dest,' '))	{
+			if (@is_file($src) && !strstr($src,' ') && !strstr($dest,' ')) {
 				$cmd = t3lib_div::imageMagickCommand('convert', $src.' '.$dest, $path);
 				exec($cmd);
 			} else die('No typo3/gfx/typo3logo.gif file!');
 			$out='';
-			if (@is_file($dest))	{
+			if (@is_file($dest)) {
 				$new_info = @getimagesize($dest);
 				clearstatcache();
 				$new_size = filesize($dest);
@@ -1983,12 +3079,14 @@
 				clearstatcache();
 				$src_size = @filesize($src);
 
-				if ($new_info[0]!=$src_info[0] || $new_info[1]!=$src_info[1] || !$new_size || !$src_size)	{
+				if ($new_info[0]!=$src_info[0] || $new_info[1]!=$src_info[1] || !$new_size || !$src_size) {
 					$out='error';
 				} else {
-					if ($new_size/$src_size > 4) {	// NONE-LZW ratio was 5.5 in test
+						// NONE-LZW ratio was 5.5 in test
+					if ($new_size/$src_size > 4) {
 						$out='NONE';
-					} elseif ($new_size/$src_size > 1.5) {	// NONE-RLE ratio was not tested
+						// NONE-RLE ratio was not tested
+					} elseif ($new_size/$src_size > 1.5) {
 						$out='RLE';
 					} else {
 						$out='LZW';
@@ -2003,23 +3101,26 @@
 	/**
 	 * Extracts the version number for ImageMagick
 	 *
-	 * @param	string		The program name to execute in order to find out the version number
-	 * @param	string		Path for the above program
-	 * @return	string		Version number of the found ImageMagick instance
+	 * @param string $file The program name to execute in order to find out the version number
+	 * @param string $path Path for the above program
+	 * @return string Version number of the found ImageMagick instance
 	 */
-	function _checkImageMagick_getVersion($file, $path)	{
+	function _checkImageMagick_getVersion($file, $path) {
 			// Temporarily override some settings
 		$im_version = $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5'];
 		$combine_filename = $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_combine_filename'];
 
-		if ($file=='gm')	{
+		if ($file=='gm') {
 			$GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5'] = 'gm';
-			$file = 'identify';		// Work-around, preventing execution of "gm gm"
-			$parameters = '-version';	// Work-around - GM doesn't like to be executed without any arguments
+				// Work-around, preventing execution of "gm gm"
+			$file = 'identify';
+				// Work-around - GM doesn't like to be executed without any arguments
+			$parameters = '-version';
 		} else {
 			$GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5'] = 'im5';
 
-			if($file=='combine' || $file=='composite')	{	// Override the combine_filename setting
+				// Override the combine_filename setting
+			if ($file=='combine' || $file=='composite') {
 				$GLOBALS['TYPO3_CONF_VARS']['GFX']['im_combine_filename'] = $file;
 			}
 		}
@@ -2040,59 +3141,101 @@
 	/**
 	 * Checks database username/password/host/database
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function checkDatabase()		{
+	function checkDatabase() {
 		$ext='Check database';
 		$this->message($ext);
 
-		if (!extension_loaded('mysql') && !t3lib_extMgm::isLoaded('dbal'))	{
-			$this->message($ext, 'MySQL not available',"
-				PHP does not feature MySQL support (which is pretty unusual).
-			",2);
+		if (!extension_loaded('mysql') && !t3lib_extMgm::isLoaded('dbal')) {
+			$this->message($ext, 'MySQL not available', '
+				<p>
+					PHP does not feature MySQL support (which is pretty unusual).
+				</p>
+			', 2);
 		} else {
-			$cInfo='
-				Username: <strong>'.TYPO3_db_username.'</strong>
-				Host: <strong>'.TYPO3_db_host.'</strong>
-			';
-			if (!TYPO3_db_host || !TYPO3_db_username)	{
-				$this->message($ext, 'Username, password or host not set',"
-					You may need to enter data for these values:
-					".trim($cInfo)."
-
-					Use the form below.
-				",2);
+			if (!TYPO3_db_host || !TYPO3_db_username) {
+				$this->message($ext, 'Username, password or host not set', '
+					<p>
+						You may need to enter data for these values:
+						<br />
+						Username: <strong>' . TYPO3_db_username . '</strong>
+						<br />
+						Host: <strong>' . TYPO3_db_host . '</strong>
+						<br />
+						<br />
+						Use the form below.
+					</p>
+				', 2);
 			}
-			if ($result = $GLOBALS['TYPO3_DB']->sql_pconnect(TYPO3_db_host, TYPO3_db_username, TYPO3_db_password))	{
-				$this->message($ext, 'Connected to SQL database successfully',"
-				".trim($cInfo)."
-				",-1,1);
+			if ($result = $GLOBALS['TYPO3_DB']->sql_pconnect(TYPO3_db_host, TYPO3_db_username, TYPO3_db_password)) {
+				$this->message($ext, 'Connected to SQL database successfully', '
+					<dl id="databaseConnected">
+						<dt>
+							Username:
+						</dt>
+						<dd>
+							' . TYPO3_db_username . '
+						</dd>
+						<dt>
+							Host:
+						</dt>
+						<dd>
+							' . TYPO3_db_host . '
+						</dd>
+					</dl>
+				', -1, 1);
 				$this->config_array['mysqlConnect']=1;
-				if (!TYPO3_db)	{
-					$this->message($ext, 'No database selected',"
-						Currently you have no database selected.
-						Please select one or create a new database.
-					",3);
+				if (!TYPO3_db) {
+					$this->message($ext, 'No database selected', '
+						<p>
+							Currently you have no database selected.
+							<br />
+							Please select one or create a new database.
+						</p>
+					', 3);
 					$this->config_array['no_database']=1;
 				} elseif (!$GLOBALS['TYPO3_DB']->sql_select_db(TYPO3_db))  {
-					$this->message($ext, 'Database',"
-						'".TYPO3_db."' could not be selected as database!
-						Please select another one or create a new database.
-					",3,1);
+					$this->message($ext, 'Database', '
+						<p>
+							\''.TYPO3_db.'\' could not be selected as database!
+							<br />
+							Please select another one or create a new database.
+						</p>
+					', 3, 1);
 					$this->config_array['no_database']=1;
 				} else  {
-					$this->message($ext, 'Database',"
-						<strong>".TYPO3_db."</strong> is selected as database.
-					",1,1);
+					$this->message($ext, 'Database', '
+						<p>
+							<strong>' . TYPO3_db . '</strong> is selected as
+							database.
+						</p>
+					', 1, 1);
 				}
 			} else {
-				$this->message($ext, 'Could not connect to SQL database!',"
-				Connecting to SQL database failed with these settings:
-				".trim($cInfo)."
+				$sqlSafeModeUser = '';
 
-				Make sure you're using the correct set of data.".($this->config_array['sql.safe_mode_user']? "
-				<strong>Notice:</strong> <em>sql.safe_mode</em> is turned on, so apparently your username to the database is the same as the scriptowner, which is '".$this->config_array['sql.safe_mode_user']."'":"")."
-				",3);
+				if ($this->config_array['sql.safe_mode_user']) {
+					$sqlSafeModeUser = '
+						<strong>Notice:</strong>
+						<em>sql.safe_mode</em> is turned on, so apparently your
+						username to the database is the same as the scriptowner,
+						which is ' . $this->config_array['sql.safe_mode_user'];
+				}
+				$this->message($ext, 'Could not connect to SQL database!', '
+					<p>
+						Connecting to SQL database failed with these settings:
+						<br />
+						Username: <strong>' . TYPO3_db_username . '</strong>
+						<br />
+						Host: <strong>' . TYPO3_db_host . '</strong>
+					</p>
+					<p>
+						Make sure you\'re using the correct set of data.
+						<br />
+						' . $sqlSafeModeUser . '
+					</p>
+				', 3);
 			}
 		}
 	}
